import { Component, Input, ViewChild, EventEmitter, Output, NgModule } from '@angular/core';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import '@angular/cdk/table';
import { FormBuilder, FormsModule, ReactiveFormsModule } from '@angular/forms';
import _ from 'lodash';
import { MatTableModule } from '@angular/material/table';
import { MatChipsModule } from '@angular/material/chips';
import { ClickOutsideModule } from 'ng-click-outside';
import { ColorPickerModule } from 'ngx-color-picker';
import { TranslateModule } from '@ngx-translate/core';
import { CommonModule } from '@angular/common';
import { MatListModule } from '@angular/material/list';
import { MatIconModule } from '@angular/material/icon';
import { MatSelectModule } from '@angular/material/select';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var TAG = 'LabelTableComponent';
var LabelTableComponent = /** @class */ (function () {
    function LabelTableComponent() {
        this.displayedColumns = ['name'];
    }
    /**
     * @return {?}
     */
    LabelTableComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        console.debug(TAG, this.dataSource);
    };
    LabelTableComponent.decorators = [
        { type: Component, args: [{
                    selector: 'chain-main-label-table',
                    template: "<div class=\"table-layout-1\" *ngIf=\"dataSource\">\n\n  <mat-table #table [dataSource]=\"dataSource\">\n    <!-- username Column -->\n    <ng-container matColumnDef=\"name\">\n      <mat-header-cell *matHeaderCellDef>{{'HEADER.NAME' | translate}}</mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <mat-chip-list>\n          <mat-chip [ngStyle]=\"{'background-color': row?.colorCode}\">{{row.name}}</mat-chip>\n        </mat-chip-list>\n      </mat-cell>\n    </ng-container>\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\"></mat-row>\n  </mat-table>\n\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    LabelTableComponent.ctorParameters = function () { return []; };
    LabelTableComponent.propDecorators = {
        displayedColumns: [{ type: Input }],
        labelFilter: [{ type: Input }],
        dataSource: [{ type: Input }],
        paginator: [{ type: ViewChild, args: [MatPaginator, { static: true },] }],
        sort: [{ type: ViewChild, args: [MatSort, { static: true },] }]
    };
    return LabelTableComponent;
}());
if (false) {
    /** @type {?} */
    LabelTableComponent.prototype.displayedColumns;
    /** @type {?} */
    LabelTableComponent.prototype.labelFilter;
    /** @type {?} */
    LabelTableComponent.prototype.dataSource;
    /** @type {?} */
    LabelTableComponent.prototype.paginator;
    /** @type {?} */
    LabelTableComponent.prototype.sort;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var TAG$1 = "LabelingComponent";
var LabelingComponent = /** @class */ (function () {
    function LabelingComponent(_formBuilder) {
        this._formBuilder = _formBuilder;
        // TODO emit a keyword for filtering
        this.selectionChange = new EventEmitter();
        this.labelAdded = new EventEmitter();
        this.navigateToAllLabels = new EventEmitter();
        this.showLabelManagement = false;
        this.showAddLabelBox = false;
    }
    /**
     * @return {?}
     */
    LabelingComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.newLabel = this._formBuilder.group({
            name: [],
            colorCode: []
        });
        if (!this.labelList) {
            this.labelAspect.findLabels((/** @type {?} */ ({})))
                .subscribe((/**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                _this.labelList = value;
            }));
        }
    };
    /**
     * @return {?}
     */
    LabelingComponent.prototype.onLabelSelectionChange = /**
     * @return {?}
     */
    function () {
        this.selectionChange.emit(this.selectedLabels);
    };
    /**
     * @return {?}
     */
    LabelingComponent.prototype.goToLabelTable = /**
     * @return {?}
     */
    function () {
        this.navigateToAllLabels.emit(true);
    };
    /**
     * @return {?}
     */
    LabelingComponent.prototype.createNewLabel = /**
     * @return {?}
     */
    function () {
        var _this = this;
        console.debug(TAG$1, "new label: ", this.newLabel.value);
        this.labelAspect.createLabel(this.newLabel.value)
            .subscribe((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            _this.labelList.push(value);
            _this.labelAdded.emit(_this.newLabel.value);
            _this.newLabel.reset();
            _this.showAddLabelBox = false;
        }));
    };
    /**
     * @param {?} color
     * @return {?}
     */
    LabelingComponent.prototype.colorPickerChange = /**
     * @param {?} color
     * @return {?}
     */
    function (color) {
        this.newLabel.value.colorCode = color;
    };
    /**
     * @param {?} label1
     * @param {?} label2
     * @return {?}
     */
    LabelingComponent.prototype.compareLabels = /**
     * @param {?} label1
     * @param {?} label2
     * @return {?}
     */
    function (label1, label2) {
        return label1.id === label2.id;
    };
    /**
     * @param {?} i
     * @return {?}
     */
    LabelingComponent.prototype.removeLabelFromSelection = /**
     * @param {?} i
     * @return {?}
     */
    function (i) {
        this.selectedLabels.splice(i, 1);
        this.selectedLabels = _.cloneDeep(this.selectedLabels);
    };
    LabelingComponent.decorators = [
        { type: Component, args: [{
                    selector: 'chain-main-labeling',
                    template: "<!--TODO Add CSS-->\n<div>\n  <div> <!--visible to the user without interaction-->\n    <button mat-button mat-raised-button (click)=\"showLabelManagement=true\" name=\"edit\">\n      <mat-icon>\n        edit\n      </mat-icon>\n    </button>\n    <div> <!--show currently selected selectedLabels-->\n      <mat-chip-list>\n        <mat-chip *ngFor=\"let label of selectedLabels; let i = index\" [ngStyle]=\"{'background-color': label.colorCode}\" (removed)=\"removeLabelFromSelection(i)\">\n          {{label.name}}\n          <mat-icon matChipRemove>cancel</mat-icon>\n        </mat-chip>\n      </mat-chip-list>\n    </div>\n  </div>\n\n  <div *ngIf=\"showLabelManagement\"> <!--only visible when the edit button is clicked-->\n    <mat-form-field color=\"accent\">\n      <input matInput placeholder=\"{{'CMD.FIND' | translate}}\">\n    </mat-form-field>\n    <!--Label selection list-->\n    <div>\n      <mat-selection-list [(ngModel)]=\"selectedLabels\" [compareWith]=\"compareLabels\" (selectionChange)=\"onLabelSelectionChange()\">\n        <mat-list-option *ngFor=\"let label of labelList\" [value]=\"label\" [ngStyle]=\"{'background-color': label.colorCode}\">\n          <div>{{label.name}}</div>\n        </mat-list-option>\n      </mat-selection-list>\n    </div>\n\n    <!--add a custom label-->\n    <div (clickOutside)=\"showAddLabelBox=false\">\n      <form [formGroup]=\"newLabel\">\n        <div class=\"field-wrap\">\n          <input matInput formControlName=\"name\" [ngStyle]=\"{'background-color': newLabel.value.colorCode}\" (click)=\"showAddLabelBox=true\" placeholder=\"{{'LABEL.ADD_NEW' | translate}}\">\n          <!--the options below are shown only when clicking on the ADD_NEW text field-->\n          <div class=\"field-wrap\" *ngIf=\"showAddLabelBox\">\n            <input matInput formControlName=\"color\" placeholder=\"{{'LABEL.COLOR' | translate}}\">\n\n            <span [style.background]=\"pickedColor\"\n                  [cpToggle]=\"true\"\n                  [cpDialogDisplay]=\"'inline'\"\n                  [cpDisableInput]=\"true\"\n                  [(colorPicker)]=\"pickedColor\"\n                  (colorPickerChange)=\"colorPickerChange($event)\">\n            </span>\n\n            <button mat-button mat-raised-button (click)=\"createNewLabel()\">\n              {{'CMD.ADD' | translate}}\n            </button>\n\n          </div>\n        </div>\n      </form>\n    </div>\n\n    <!--navigate to a table of all labels-->\n    <button mat-button mat-raised-button (click)=\"goToLabelTable()\">\n      {{'LABEL.MANAGE' | translate}}\n    </button>\n\n  </div>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    LabelingComponent.ctorParameters = function () { return [
        { type: FormBuilder }
    ]; };
    LabelingComponent.propDecorators = {
        selectedLabels: [{ type: Input }],
        labelList: [{ type: Input }],
        labelAspect: [{ type: Input }],
        selectionChange: [{ type: Output }],
        labelAdded: [{ type: Output }],
        navigateToAllLabels: [{ type: Output }]
    };
    return LabelingComponent;
}());
if (false) {
    /** @type {?} */
    LabelingComponent.prototype.selectedLabels;
    /** @type {?} */
    LabelingComponent.prototype.labelList;
    /** @type {?} */
    LabelingComponent.prototype.labelAspect;
    /** @type {?} */
    LabelingComponent.prototype.selectionChange;
    /** @type {?} */
    LabelingComponent.prototype.labelAdded;
    /** @type {?} */
    LabelingComponent.prototype.navigateToAllLabels;
    /** @type {?} */
    LabelingComponent.prototype.newLabel;
    /** @type {?} */
    LabelingComponent.prototype.showLabelManagement;
    /** @type {?} */
    LabelingComponent.prototype.showAddLabelBox;
    /** @type {?} */
    LabelingComponent.prototype.pickedColor;
    /**
     * @type {?}
     * @private
     */
    LabelingComponent.prototype._formBuilder;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ChainMainLabel = /** @class */ (function () {
    function ChainMainLabel() {
    }
    ChainMainLabel.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        LabelTableComponent,
                        LabelingComponent
                    ],
                    imports: [
                        ColorPickerModule,
                        ClickOutsideModule,
                        CommonModule,
                        MatChipsModule,
                        TranslateModule,
                        MatTableModule,
                        MatListModule,
                        FormsModule,
                        ReactiveFormsModule,
                        MatIconModule,
                        MatSelectModule
                    ],
                    exports: [
                        LabelTableComponent,
                        LabelingComponent
                    ],
                    entryComponents: [],
                    schemas: []
                },] }
    ];
    return ChainMainLabel;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ChainMainLabel, LabelTableComponent as ɵa, LabelingComponent as ɵb };
//# sourceMappingURL=yukawa-chain-main-angular-comp.js.map
